require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Application Deployment Kit.
  module OS
    # Module Command.
    module Command
      # @see Command#set_attributes
      class CommandSetAttributes < UU::OS::REST::DTO

        # @see Command#set_attributes
        # @return [String]
        attr_accessor :name

        # @see Command#set_attributes
        # @return [String]
        attr_accessor :code

        # @see Command#set_attributes
        # @return [String]
        attr_accessor :description

        # @see Command#set_attributes
        # @return [UU::OS::Artifact::SecurityLevel]
        attr_accessor :security_level

        # @see Command#set_attributes
        # @return [UU::OS::UESURI]
        attr_accessor :icon_uri

        # @see Command#set_attributes
        # @return [String]
        attr_accessor :controller_url_path

        # @see Command#set_attributes
        # @return [TrueClass, FalseClass]
        attr_accessor :asynchronous

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def controller_url_path
          attributes[:controllerUrlPath]
        end

        def controller_url_path=(val)
          attributes[:controllerUrlPath] = val
        end

        def asynchronous
          attributes[:asynchronous]
        end

        def asynchronous=(val)
          attributes[:asynchronous] = val
        end

      end
    end
  end

end
