require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS

    module PersonalRole
      class TerritoryAttributes < UU::OS::REST::DTO

        # Normalized UESURI of the territory. Never nil.
        attr_accessor :uri

        # Name of the territory. Never nil.
        attr_accessor :name

        # Code of the territory. Never nil.
        attr_accessor :code

        # Type of the territory. Never nil.
        attr_accessor :type

        # Specifies if this territory is the preferred territory of the personal role's user. Never nil.
        attr_accessor :preferred

        # Access role into the territory, that make accessible the territory to the user of the personal role. Never nil.
        attr_accessor :access_role_uri

        # UESURI of the entity type of the territory. Never null.
        attr_accessor :entity_type_uri
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def preferred
          attributes[:preferred]
        end

        def preferred=(val)
          attributes[:preferred] = val
        end

        def access_role_uri
          attributes[:accessRoleUri]
        end

        def access_role_uri=(val)
          if val
            attributes[:accessRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:accessRoleUri] = nil
          end
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end

    end
  end

end
