require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Role
      class RoleGetRoleInterfaceListItem < UU::OS::REST::DTO

        # Normalized UESURI of the role. Never nil.
        attr_accessor :uri

        # Name of the role. Never nil.
        attr_accessor :name

        # Code of the role. Never nil.
        attr_accessor :code

        # UESURI of the entity type of the role. Never nil.
        attr_accessor :entity_type_uri
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end
  end
end
