require 'uu/os/rest/dto'

# Module Unicorn Universe.
module UU
  # Module Application Deployment Kit.
  module OS
    # Module Visual Use Case.
    module VisualUseCase
      # @see VisualUseCase#get_use_case_list
      class VisualUseCaseGetUseCaseListItem < UU::OS::REST::DTO

        # Code of the connected use case. Never nil.
        attr_accessor :code

        # Name of the connected use case. Never nil.
        attr_accessor :name

        # Normalized UESURI of the connected use case. Never nil.
        attr_accessor :uri

        # UESURI of the entity type of the use case (@see cz.ues.platform.sysc.entitytype.UESEntityType for more info). Never nil.
        attr_accessor :entity_type_uri
        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end
end
